PROGRAM PulseWidth
IMPLICIT NONE

! Imput file should look like:	No. of Data Points - DatPts (Integer)
!								Data point 1
!								Data point 2
!								....
!								Data point (DatPts - 1)
!								Data point (DatPts)


REAL :: max, min, diff, stepsize
INTEGER :: DatPts						!!!Number of Data points in file!!!
INTEGER :: i, j							!!!Used for Do Loops!!!
REAL, DIMENSION(10000) :: YPos			!!!Array containing positions of electrons!!!
REAL, DIMENSION(10000,2):: Bins			!!!Array to gather data on pulse width!!!
INTEGER :: Steps
!Character :: IN
!Character :: OUT

stepsize = 0.01

!WRITE(6,*) "Please enter the location of the file you want to read:"
!READ*, IN
!WRITE(6,*) "Please enter the location of the file you want to write to:"
!READ*, OUT

!OPEN (unit=10, file=IN)	!!!File you want to read Data from!!!
!OPEN (Unit=11, file=OUT)			!!!File you want to write Data to!!!

OPEN (unit=10, file="C:\Documents and Settings\s0674682\Desktop\Width Input.txt")	!!!File you want to read Data from!!!
OPEN (Unit=11, file="C:\Documents and Settings\s0674682\Desktop\Width Output.txt")			!!!File you want to write Data to!!!
READ (10,*) DatPts


!!!The first column of the Bin Array collects position, second column collects no. of Electrons that fall in that range!!!
!!!First we Set the no of electrons at each position initally to 0!!!

Bins(:,2:2)=0	

!!!Now we read all of the data points into the "YPos" Array
DO i=1, DatPts, 1
	READ(10,*) YPos(i)
END DO

!!! A Check to see if the program is reading the data point correctly!!!
!DO i=1, DatPts, 1
!WRITE (6,*) YPos(i)
!END DO


!!!Now find MAX and MIN Values, and no. of steps we should take!!!
max = MAXVAL(YPos(1:DatPts))
min = MINVAL(YPos(1:DatPts))
diff = max-min
Steps= (diff/stepsize) +1


!!! DO loops. First determines the region that we are analysing and notes this down in the Bin Array!!!
!!! The next determines whether or not the electron/data-point is within that region and then informs the Bin Array of it's results" 

Do i=0, Steps, 1
	!Write (11,*) "Position : ", (min + (0.5+i)*stepsize)
	Bins((i+1),1)= (min + (0.5+i)*stepsize)
	Do j=1, DatPts, 1
		If ((min+(i*stepsize))<= YPos(j) .AND. YPos(j)<=(min+((i+1)*stepsize))) Then
		!If (min <= Ypos(j) .AND. YPos(j)<= (min + 0.01)) Then
			!WRITE (11,*) YPos(j)
			Bins((i+1),2) = Bins((i+1),2) + 1
		END IF
	END DO
END DO


!!! A series of WRITE commands to print data to the designated file we want !!!


WRITE(11,*) "Data File size: ", DatPts
WRITE(11,*) "Max Electron Position:", "	", max
WRITE(11,*) "Min Electron Position:", "	", min 
WRITE(11,*) "Difference between Max/Min:", "	", diff

!WRITE (6,*) "Steps :", Steps
DO i=0, Steps, 1
	WRITE (11,*) Bins((i+1),1), "	", Bins((i+1),2)
END DO

END PROGRAM PulseWidth

