PROGRAM PulseDuration

IMPLICIT NONE

! Imput file should look like:	No. of Data Points - DatPts (Integer)
!								Data point 1
!								Data point 2
!								....
!								Data point (DatPts - 1)
!								Data point (DatPts)
!!! MUST ENSURE THAT THE ELECTRON@S TOF IS IN CHRONOLOGICAL ORDER, AND IN NON_SCIENTIF TERMS I.E. 100,000 not 1E5!!!
!!!NOTE: The input file will repeat itself so it it inportnat to only look at the binning data until we see a time step that 
!!!      comes out at t=0.0000000 with 0.0000 electrons.

REAL :: max, min, diff
INTEGER :: DatPts						!!!Number of Data points in file!!!
INTEGER :: i, j, k   					!!!Used for Do Loops!!!
REAL, DIMENSION(10000) :: TOF			!!!Array containing positions of electrons!!!
REAL, DIMENSION(700,2):: Bins			!!!Array to gather data on pulse width!!!
INTEGER :: Steps
!Character :: IN
!Character :: OUT


!WRITE(6,*) "Please enter the location of the file you want to read:"
!READ*, IN
!WRITE(6,*) "Please enter the location of the file you want to write to:"
!READ*, OUT

!OPEN (unit=10, file=IN)	!!!File you want to read Data from!!!
!OPEN (Unit=11, file=OUT)			!!!File you want to write Data to!!!

OPEN (unit=10, file="C:\Documents and Settings\s0674682\Desktop\PulseDur_Input.txt")	!!!File you want to read Data from!!!
OPEN (Unit=11, file="C:\Documents and Settings\s0674682\Desktop\PulseDur_Out.txt")			!!!File you want to write Data to!!!
READ (10,*) DatPts


!!!The first column of the Bin Array collects position, second column collects no. of Electrons that fall in that range!!!
!!!First we Set the no of electrons at each position initally to 0!!!

Bins(:,2:2)=0	

!!!Now we read all of the data points into the "YPos" Array
DO i=1, DatPts, 1
!	READ(10,*) TOF(i)
	READ(10,"(F17.15)") TOF(i)
	END DO

!!! A Check to see if the program is reading the data point correctly!!!
!DO i=1, DatPts, 1
!WRITE (6,*) TOF(i)
!END DO


!!!Now find MAX and MIN Values, and no. of steps we should take!!!
max = MAXVAL(TOF(1:DatPts))
min = MINVAL(TOF(1:DatPts))
diff = max-min
!Steps= (diff/0.025) +1


!!! DO loops. These loops use the 2-d Bins array to look at the input file. As SIMION works with time steps, there will be
!!! a group of electrons that pass the same point at the same time, effecively binning the data for us. This looks to see how many
!!! electrons arrive a specific time, and recors the time an no. of occurences of that time. It is important for this that the input 
!!! file is in chronological order or it will not work.
 

Outer: DO k=1, 700, 1
Inner: Do i=1, DatPts, 1

		
		IF (i==1 .AND. k==1) Then
			Bins(1,1) = TOF(1)
			Bins(1,2) = Bins(1,2) + 1
		Cycle Inner

		Else IF (Bins(k,1) == TOF(i)) THEN
			Bins((k),2) = Bins((k),2) + 1
			
		
		ELSE IF (Bins(k,1) /= TOF(i) .AND. TOF(i) > Bins(k,1) .AND. k<700) THEN
			Bins(k+1,1) = TOF(i)
		Cycle Outer

		END IF


!	Write (11,*) "Position : ", (min + (0.5+i)*0.025)
!	Bins((i+1),1)= (min + (0.5+i)*0.025)
!	Do j=1, DatPts, 1
!		If ((min+(i*0.025))<= TOF(j) .AND. TOF(j)<=(min+((i+1)*0.025))) Then
!		!If (min <= TOF(j) .AND. TOF(j)<= (min + 0.01)) Then
!			!WRITE (11,*) TOF(j)
!			Bins((i+1),2) = Bins((i+1),2) + 1
!		END IF
	END DO Inner
END DO Outer


!!! A series of WRITE commands to print data to the designated file we want !!!


WRITE(11,*) "Data File size: ", DatPts
WRITE(11,*) "Slowest Electron: ", max
WRITE(11,*) "Fastest Electron: ", min 
WRITE(11,*) "Difference between Max/Min: ", diff

!WRITE (6,*) "Steps :", Steps
DO k=1, 700, 1
	WRITE (11,"(F17.15,A1, F5.1)") Bins(k,1), "	", Bins(k,2)
END DO

END PROGRAM PulseDuration

