clear
%read in all the name of the Text file of interest that is grepp coords of 
%interest from Newton-X dyn.out 
Filename = input('File to be analysed: ','s');
fileID = fopen(Filename,'r');
%tell the program how many atoms there are in the molecule
N = input('Number of atoms: ');
% tell the program how many steps have been looked at
Steps = input('Number of steps: ');

Bohr = 0.529177249; % Convert data to Angstoms from Bohr

B=zeros(((N+2)*Steps),4); % File for storing coordinates
for l=1:Steps
    %Reading in the Initial coordiantes
    if l==1
        for j=1:(N+1)
            if j==1 %Read in the number of atoms from data sheet
                A=fscanf(fileID,'%s',[1 2]);
                B(j,1)=N;
            else %Read mol. structure data
                for i=1:6
                    if i==1 %Read but ignore first coloumn
                        Nope=fscanf(fileID,'%s',1);
                    elseif i==2 %Read atomic number
                        k=fscanf(fileID,'%f',1);    
                        B(j+1,i-1)=k;                    
                    elseif i>2 && i<6 %Read atomic coords
                        k=fscanf(fileID,'%f',1);    
                        B(j+1,i-1)=k*Bohr;
                    else %Read but ignore last column
                        Nope=fscanf(fileID,'%s',1);
                    end
                end
            end
        end
    else
        %Repeat the above loop but for the rest of the stpes.
        S=(l-1)*(N+2);
        for j=1:(N+1)
            if j==1
                A=fscanf(fileID,'%s',[1 3]);
                B((S+j),1)=N;
            else
                for i=1:6
                    if i==1
                        Nope=fscanf(fileID,'%s',1);
                    elseif i==2
                        k=fscanf(fileID,'%f',1);    
                        B(S+j+1,i-1)=k;               
                    elseif i>2 && i<6
                        k=fscanf(fileID,'%f',1);    
                        B((S+j+1),i-1)=k*Bohr;
                    else
                        Nope=fscanf(fileID,'%s',1);
                    end
                end
            end
        end
    end
end
fclose(fileID);
%Write a simple xyz file to be able to read by Avogadro
dlmwrite([Filename,'.xyz'],B,'delimiter','\t')

% Create more complicated xyz file for MDSim
fileID = fopen('MDSim.xyz','w');

for i = 1: Steps;
    fprintf(fileID,'%d\n',N);
    fprintf(fileID,'STEP: %d\n',i);
    k=(i-1)*(N+2);
    for j = 1:N,
        %will need to add lines here if you want to look at certain atoms.
        %to do so just copy-paste the elseif and replace the atomic #.
        if B(k+j+2,1)==1 %Hydrogen
           fprintf(fileID,'  H\t %f\t %f\t %f\n',B(k+j+2,2:4));
        elseif B(k+j+2,1)==6 %Carbon
           fprintf(fileID,'  C\t %f\t %f\t %f\n',B(k+j+2,2:4));
        elseif B(k+j+2,1)==16 %Sulfur
           fprintf(fileID,'  S\t %f\t %f\t %f\n',B(k+j+2,2:4));
        elseif B(k+j+2,1)==7 %Nitrogen
           fprintf(fileID,'  N\t %f\t %f\t %f\n',B(k+j+2,2:4));
        else
            disp(' ');
            disp(' ');
            disp('! ! ! ! ! ! ! ');
            X=['Atomic number ', num2str(B(k+j+2,1)),' is not currently available.'];
            disp(X);
            disp('Please go into code and follow instructions to insert it');
            disp('! ! ! ! ! ! ! ');
            disp(' ');
            break
        end
    end
end
fclose(fileID);


