%Mock Diffraction code for producing moock images from theoretical
%scattering curves
%For this to work, you need to have a vetor called I, whose size is (N,1)
%where N is the number of data points in your theoretical scattering curve

% Define centre of diffraction image 
Xcentre = input('Enter image centre X-value: ');
% check to ensure that integer value has been used for coordinate
if((ceil(Xcentre)-Xcentre)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

Ycentre = input('Enter image centre Y-value: ');
if((ceil(Ycentre)-Ycentre)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

% Define angles over which image is to be scanned
ThetaStart = 0 
ThetaEnd = 360 
% determine the number of angle iterations
ThetaRange = (ThetaEnd-ThetaStart);

% determine the angle increment value between line scans
ThetaInc = input('Enter the value incremetal value for the image: ');
Ntheta = ThetaRange/ThetaInc; % Calc the number of iterations needed
if(ceil(Ntheta)-(Ntheta)>0)
    disp(' ')
    disp('Increment must fit into angle scan a whole number of times!')
    break
end
    
% Define outer scan radius
rMax = input('Enter out radius length, in pixels, for scan: ');
if(rMax<1)
    disp(' ')
    disp('Radius must be bigger than one pixel!')
    break
end
if((ceil(rMax)-rMax)>0)
    disp(' ')
    disp('Value must be an integer value!')
    break
end

%set size of complete Intensity matrix
DiffImage = zeros(768,1024,3);
% variable to fill in angles data correctly
k=0;
%For loop to scan through and record data
for Theta=ThetaStart:ThetaInc:ThetaEnd,
    k=k+1; %step through the boxes as we go
    for r=1:rMax,
        x=Xcentre + round(r*cosd(Theta));
        y=Ycentre - round(r*sind(Theta));
        DiffImage(y,x,1)=I(r); %Y-axis is in first colum of image
        DiffImage(y,x,2)=I(r);
        DiffImage(y,x,3)=I(r);
    end
end

image(mat2gray(DiffImage));