% Line that allows us to combine sets of data with different core names
A = input('Number of file sets to be analysed: ');

% This variable is used to calculate the total number of images that 
% are being stacked.
TotN=0;

for k=1:A,
    
    % Line that one enters in the total number of pictures to look at.
    N = input('Number of files to be analysed: ');
    TotN=TotN+N;
    
    % Here we insert the core name of the files that we wish to look at
    % i.e. "File_name_%d.bmp", where "%d" allows for the code to iterate
    % through sequentially numbered files.
    Name = input('File name: ','s');

    % This is the variable where all of the images are stacked.
    Stack=zeros(768,1024,3);

    % This is where the images are read in and stacked and then the 
    % read information is wiped in the next loop, whilst the stacked
    % information remains. 
    for i=1:N,
        a = imread(sprintf(Name, i));
        b = mat2gray(a);
        Stack = Stack+b;
    end 
    
    if (k<A),
        disp('   ')
        disp('COMPLETED STACKING FOR THIS SET!')
        disp('PLEASE ENTER NEXT SET!')
        disp('   ')
    end
    if (k==A),
        disp('   ')
        disp('STACKING COMPLETE. NOW PRODUCING IMAGE!')
        disp('   ')
    end
end
Stack=Stack/TotN;
mat2gray(Stack);
image(Stack);
