%Extraction code for Stingray camera

% Define centre of diffraction image 
Xcentre = input('Enter images centre X-value: ');
% check to ensure that integer value has been used for coordinate
if((ceil(Xcentre)-Xcentre)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

Ycentre = input('Enter images centre Y-value: ');
if((ceil(Ycentre)-Ycentre)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

% Define angles over which image is to be scanned
ThetaStart = input('Enter initial angle for scan: ');
if((ceil(ThetaStart)-ThetaStart)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

ThetaEnd = input('Enter final angle for scan: ');
if((ceil(ThetaEnd)-ThetaEnd)>0)
    disp(' ')
    disp('Value must be an integer value!');
    break
end

%Check that the starting angle is smaller than the final angle
if(ThetaStart>ThetaEnd)
    disp(' ')
    disp('Initial angle must be smaller than final angle!')
    break
end

% determine the number of angle iterations
ThetaRange = (ThetaEnd-ThetaStart);

% determine the angle increment value between line scans
ThetaInc = input('Enter the value incremetal value for angle scan: ');
Ntheta = ThetaRange/ThetaInc; % Calc the number of iterations needed
if(ceil(Ntheta)-(Ntheta)>0)
    disp(' ')
    disp('Increment must fit into angle scan a whole number of times!')
    break
end
    
% Define outer scan radius
rMax = input('Enter out radius length, in pixels, for scan: ');
if(rMax<1)
    disp(' ')
    disp('Radius must be bigger than one pixel!')
    break
end
if((ceil(rMax)-rMax)>0)
    disp(' ')
    disp('Value must be an integer value!')
    break
end

%set size of complete Intensity matrix
IntMatrix = zeros(rMax,Ntheta);
% variable to fill in angles data correctly
k=0;
%For loop to scan through and record data
for Theta=ThetaStart:ThetaInc:ThetaEnd,
    k=k+1; %step through the boxes as we go
    for r=1:rMax,
        x=Xcentre + round(r*cosd(Theta));
        y=Ycentre - round(r*sind(Theta));
        IntMatrix(r,k)=Red(y,x,1); %Y-axis is in first colum of image
    end
end

I=zeros(rMax,1);
for i=1:rMax,
    for j=1:Ntheta,
        I(i,1)= I(i,1) + IntMatrix(i,j);
    end
end
I=I/Ntheta;
plot(I);